<template>
  <div class="mobile-banner" :class="actived">
    <swiper
      :slides-per-view="1"
      :scrollbar="{ draggable: true }"
      :pagination="{ clickable: true }"
      :autoplay="{
        delay: 4000,
        disableOnInteraction: false,
      }"
      :modules="modules"
      :navigation="true"
      :loop="themeBannerForDisplay.length > 1 ? true : false"
      class="flex content-center w-full custom-swiper-mobile"
      v-if="!bannerLoading"
    >
      <swiper-slide v-for="(item, index) in themeBannerForDisplay" :key="index">
        <div class="h-[160px]">
          <nuxt-link :to="item.HyperLink" :id="ID.LOBBY_BANNER[item.HtmlId]">
            <div class="img-container pointer-events-none">
              <div
                class="blur-background"
                :style="{ 'background-image': 'url(' + item.ImagePath + ')' }"
              ></div>
              <img
                :src="item.ImagePath"
                class="mx-auto relative w-full h-full object-contain"
                loading="lazy"
              />
            </div>
          </nuxt-link>
        </div>
      </swiper-slide>
    </swiper>
  </div>
</template>
<script lang="ts">
import { computed, defineComponent, PropType, toRefs } from "vue";
import { Autoplay, Navigation, Pagination } from "swiper";
import {
  IThemePropertiesFromApi,
  ThemePropertiesFromApiDto,
} from "@/models/companyThemePropertiesRespone";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { store } from "@/store";
import { ID } from "~~/utils/constants";
import commonHelper from "@/utils/commonHelper";

const bannerKeys: Record<string, string> = {
  HomeInitial: "lobby_banner",
  SportInitial: "sport_banner_",
  VirtualSportInitial: "virtual_sport_banner_",
  LiveCasinoInitial: "live_casino_banner_",
  GameInitial: "game_banner_",
  PokerInitial: "poker_banner_",
  CockfightInitial: "cockfight_banner_",
  PromotionInitial: "promotion_banner_",
  LotteryInitial: "lottery_banner_",
};
export default defineComponent({
  name: "MBanner",
  props: {
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
    actived: {
      type: String,
      default: "HomeInitial",
    },
  },
  emits: ["hasBanner"],
  setup(props, { emit }) {
    const { themeProperties, actived } = toRefs(props);
    const themeName = computed((): string => store.state.selectedThemeName);
    const bannerKey = bannerKeys[actived.value]
      ? bannerKeys[actived.value]
      : bannerKeys.HomeInitial;
    const themeBannerForDisplay = computed(
      (): Array<ThemePropertiesFromApiDto> => {
        let banners = themePropertyHelper.getMultipleThemesProperties(
          themeProperties.value,
          bannerKey
        );
        if (actived.value === "SportInitial") {
          banners = banners.filter(
            (banner) => !banner.HtmlId.includes("virtual_")
          );
        }
        emit("hasBanner", banners.length > 0);
        return banners;
      }
    );
    const bannerLoading = computed(
      () => themeBannerForDisplay.value.length === 0
    );

    return {
      themeBannerForDisplay,
      bannerLoading,
      bannerKey,
      modules: [Autoplay, Pagination, Navigation],
      themeName,
    };
  },
});
</script>

<style scoped lang="scss">
.el-carousel {
  --el-carousel-indicator-width: 5px;
  --el-carousel-indicator-height: 5px;
}
:deep(.el-carousel__button) {
  border-radius: 2px;
}
</style>
